package me.hammerle.snuviengine.game;

import me.hammerle.snuviengine.api.Shader;
import me.hammerle.snuviengine.util.Face;

public class Hero extends Entity
{
    public Hero(Game game, double width, double height)
    {
        super(game, width, height);
    }
    
    @Override
    public void renderTick(float lag)
    {
        Shader.getColorRenderer().setDepth((float) yPos);
        float x = (float) (lastXPos + (xPos - lastXPos) * lag);
        float y = (float) (lastYPos + (yPos - lastYPos) * lag);
        Shader.getColorRenderer().drawRectangle(x, y, (float) (x + width), (float) (y + height), 0xAAFF0000);
    }

    @Override
    public void tick()
    {
        double nvx = 0.0;
        double nvy = 0.0;
        double speed = 5;
        
        if(Game.DOWN.isDown())
        {
            nvy += speed;
        }
        
        if(Game.UP.isDown())
        {
            nvy -= speed;
        }
        
        if(Game.LEFT.isDown())
        {
            nvx -= speed;
        }
        
        if(Game.RIGHT.isDown())
        {
            nvx += speed;
        }
        
        vx = nvx;
        vy = nvy;
        
        super.tick();
    }

    @Override
    public void onCollide(Face f, Entity ent)
    {
        
    }
}
