package me.hammerle.snuviengine.util;

import java.io.IOException;
import java.io.InputStream;

public class WrappedInputStream
{
    private final InputStream in;
    
    public WrappedInputStream(InputStream in)
    {
        this.in = in;
    }
    
    private int read() throws IOException
    {
        int i = in.read();
        if(i == -1)
        {
            throw new IOException("end of stream");
        }
        return i;
    }
    
    public byte readByte() throws IOException
    {
        return (byte) read();
    }
    
    public int readUnsignedByte() throws IOException
    {
        return read();
    }
    
    public short readShort() throws IOException
    {
        return (short) (read() | (read() << 8));
    }
    
    public int readInt() throws IOException
    {
        return read() | (read() << 8) | (read() << 16) | (read() << 24);
    }
    
    public long readLong() throws IOException
    {
        return ((long) read()) | (((long) read()) << 8) | (((long) read()) << 16) | (((long) read()) << 24) | 
                (((long) read()) << 32) | (((long) read()) << 40) | (((long) read()) << 48) | (((long) read()) << 56);
    }
    
    public String readString() throws IOException
    {
        byte[] b = new byte[readInt()];
        for(int i = 0; i < b.length; i++)
        {
            b[i] = (byte) read();
        }
        return new String(b);
    }
}
